*** empty log message ***
[platform/upstream/coreutils.git] / Makefile.maint
index 0547570..6d28393 100644 (file)
@@ -2,7 +2,7 @@
 # This Makefile fragment is shared between the coreutils,
 # CPPI, Bison, and Autoconf.
 
-## Copyright (C) 2001-2005 Free Software Foundation, Inc.
+## Copyright (C) 2001-2006 Free Software Foundation, Inc.
 ##
 ## This program is free software; you can redistribute it and/or modify
 ## it under the terms of the GNU General Public License as published by
 ##
 ## You should have received a copy of the GNU General Public License
 ## along with this program; if not, write to the Free Software
-## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
-## 02111-1307, USA.
+## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+## 02110-1301, USA.
 
 # This is reported not to work with make-3.79.1
 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
 ME := Makefile.maint
 
 # Do not save the original name or timestamp in the .tar.gz file.
-GZIP_ENV = '--no-name --best'
+# Use --rsyncable if available.
+gzip_rsyncable := \
+  $(shell gzip --help|grep rsyncable >/dev/null && echo --rsyncable)
+GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
 
 CVS = cvs
 
-CVS_LIST = cvsu --find --types=AFGM
+# cvsu is part of the cvsutils package: http://www.red-bean.com/cvsutils/
+CVS_LIST = sh -c ' \
+    if test -x $(srcdir)/build-aux/cvsu; then \
+      $(srcdir)/build-aux/cvsu --find --types=AFGM $$*; \
+    else \
+      awk -F/ '\''{ \
+         if (!$$1 && $$3 !~ /^-/) { \
+           f=FILENAME; \
+           sub(/CVS\/Entries/, "", f); \
+           print f $$2; \
+         }}'\'' \
+       $$(find $${*-*} -name Entries -print) /dev/null; \
+    fi \
+  ' dummy
+
+CVS_LIST_EXCEPT = \
+  $(CVS_LIST) | if test -f .x-$@; then grep -vEf .x-$@; else grep -v ChangeLog; fi
 
 ifeq ($(origin prev_version_file), undefined)
   prev_version_file = .prev-version
 endif
 
 PREV_VERSION := $(shell cat $(prev_version_file))
+VERSION_REGEXP = $(subst .,\.,$(VERSION))
 
 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
 tag-this-version = $(subst .,_,$(VERSION))
@@ -55,103 +75,116 @@ export LC_ALL = C
 ## Sanity checks.  ##
 ## --------------- ##
 
+# FIXME: add a check to prohibit definition in src/*.c of symbols defined
+# in system.h.  E.g. today I removed from tail.c a useless definition of
+# ENOSYS.  It was useless because system.h ensures it's defined.
+
 # Checks that don't require cvs.
 # Run `changelog-check' last, as previous test may reveal problems requiring
 # new ChangeLog entries.
 local-checks-available = \
   po-check copyright-check writable-files m4-check author_mark_check \
-  changelog-check strftime-check syntax-check makefile_path_separator_check \
+  changelog-check patch-check strftime-check $(syntax-check-rules) \
+  makefile_path_separator_check \
   makefile-check
 .PHONY: $(local-checks-available)
 
 local-check = $(filter-out $(local-checks-to-skip), $(local-checks-available))
 
+# Collect the names of rules starting with `sc_'.
+syntax-check-rules := $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(ME))
 .PHONY: $(syntax-check-rules)
-syntax-check-rules = \
-  sc_cast_of_argument_to_free \
-  sc_cast_of_x_alloc_return_value \
-  sc_cast_of_alloca_return_value \
-  sc_changelog \
-  sc_dd_max_sym_length \
-  sc_error_exit_success \
-  sc_file_system \
-  sc_prohibit_atoi_atof \
-  sc_prohibit_jm_in_m4 \
-  sc_root_tests \
-  sc_space_tab \
-  sc_sun_os_names \
-  sc_system_h_headers \
-  sc_tight_scope \
-  sc_trailing_blank \
-  sc_unmarked_diagnostics
 
 syntax-check: $(syntax-check-rules)
-#      @grep -E '#  *include <(limits|std(def|arg|bool))\.h>'          \
+#      @grep -nE '#  *include <(limits|std(def|arg|bool))\.h>'         \
 #          $$(find -type f -name '*.[chly]') &&                        \
 #        { echo '$(ME): found conditional include' 1>&2;               \
 #          exit 1; } || :
 
-#      grep -E '^#  *include <(string|stdlib)\.h>'                     \
+#      grep -nE '^#  *include <(string|stdlib)\.h>'                    \
 #          $(srcdir)/{lib,src}/*.[chy] &&                              \
 #        { echo '$(ME): FIXME' 1>&2;                                   \
 #          exit 1; } || :
 # FIXME: don't allow `#include .strings\.h' anywhere
 
 sc_cast_of_argument_to_free:
-       @grep -E '\<free \(\(' $(srcdir)/{lib,src}/*.[chly] &&          \
+       @grep -nE '\<free \(\(' $(srcdir)/{lib,src}/*.[chly] &&         \
          { echo '$(ME): don'\''t cast free argument' 1>&2;             \
            exit 1; } || :
 
 sc_cast_of_x_alloc_return_value:
-       @grep -E --exclude=$(srcdir)/lib/regex.c                        \
+       @grep -nE --exclude=$(srcdir)/lib/regex.c                       \
            '\*\) *x(m|c|re)alloc\>'                                    \
            $(srcdir)/{lib,src}/*.[chy] &&                              \
          { echo '$(ME): don'\''t cast x*alloc return value' 1>&2;      \
            exit 1; } || :
 
 sc_cast_of_alloca_return_value:
-       @grep -E '\*\) *alloca\>'                                       \
+       @grep -nE '\*\) *alloca\>'                                      \
            $(srcdir)/src/*.[chy] &&                                    \
          { echo '$(ME): don'\''t cast alloca return value' 1>&2;       \
            exit 1; } || :
 
 sc_space_tab:
-       @( $(CVS_LIST) ) > /dev/null 2>&1 || : &&                       \
-         grep '[ ]     '                                               \
-            $$($(CVS_LIST) | grep -vEf .x-$@ ) &&                      \
+       @grep -n '[ ]   ' $$($(CVS_LIST_EXCEPT)) &&                     \
          { echo '$(ME): found SPACE-TAB sequence; remove the SPACE'    \
                1>&2; exit 1; } || :
 
-# Don't use atoi, atof, atol, atoll, or atoq in `real' code.
+# Don't use the old ato* functions in `real' code.
 # They provide no error checking mechanism.
 # Instead, use strto* functions.
 sc_prohibit_atoi_atof:
-       @( $(CVS_LIST) ) > /dev/null 2>&1 || : &&                       \
-         grep -E '\<(ato[filq]|atoll)\>'                               \
-            $$($(CVS_LIST) | grep -vEf .x-$@ ) &&                      \
-         { echo '$(ME): do not use atof, atoi, atol, atoll, or atoq'   \
+       @grep -nE '\<ato([filq]|ll)\>' $$($(CVS_LIST_EXCEPT)) &&        \
+         { echo '$(ME): do not use ato''f, ato''i, ato''l, ato''ll, or ato''q' \
                1>&2; exit 1; } || :
 
 # Using EXIT_SUCCESS as the first argument to error is misleading,
 # since when that parameter is 0, error does not exit.  Use `0' instead.
 sc_error_exit_success:
-       @grep -F 'error (EXIT_SUCCESS,'                                 \
+       @grep -nF 'error (EXIT_SUCCESS,'                                        \
            $$(find -type f -name '*.[chly]') &&                        \
          { echo '$(ME): found error (EXIT_SUCCESS' 1>&2;               \
            exit 1; } || :
 
 sc_file_system:
-       @grep -i 'filesystem'                                           \
-            $$($(CVS_LIST) | grep -vEf .x-$@ ) &&                      \
-         { echo '$(ME): found use of "filesystem";'                    \
+       @grep -ni 'file''system' $$($(CVS_LIST_EXCEPT)) &&              \
+         { echo '$(ME): found use of "file''system";'                  \
            'rewrite to use "file system"' 1>&2;                        \
            exit 1; } || :
 
+sc_no_if_have_config_h:
+       @grep -n '^# *if HAVE_CONFIG_H' $$($(CVS_LIST_EXCEPT)) &&       \
+         { echo '$(ME): found use of #if HAVE_CONFIG_H; use #ifdef'    \
+               1>&2; exit 1; } || :
+
+# Nearly all .c files must include <config.h>.
+sc_require_config_h:
+       @grep -L '^# *include <config\.h>'                              \
+               $$($(CVS_LIST_EXCEPT) | grep '\.c$$')                   \
+           | grep . &&                                                 \
+         { echo '$(ME): the above files do not include <config.h>'     \
+               1>&2; exit 1; } || :
+
+# Prohibit the inclusion of assert.h without an actual use of assert.
+sc_prohibit_assert_without_use:
+       @files=$$(grep -l '# *include <assert\.h>'                      \
+                   $$($(CVS_LIST_EXCEPT) | grep '\.c$$')) &&           \
+       grep -L '\<assert (' $$files                                    \
+           | grep . &&                                                 \
+         { echo "$(ME): the above files include <assert.h> but don't use it" \
+               1>&2; exit 1; } || :
+
+sc_obsolete_symbols:
+       @grep -nE '\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
+            $$($(CVS_LIST_EXCEPT)) &&                                  \
+         { echo '$(ME): do not use HAVE''_FCNTL_H or O''_NDELAY'       \
+               1>&2; exit 1; } || :
+
 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
 
 # Each nonempty line must start with a year number, or a TAB.
 sc_changelog:
-       @grep '^[^12    ]' $$(find . -maxdepth 2 -name ChangeLog) &&    \
+       @grep -n '^[^12 ]' $$(find . -maxdepth 2 -name ChangeLog) &&    \
          { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2;  \
            exit 1; } || :
 
@@ -159,30 +192,31 @@ sc_changelog:
 # with the strings from the two affected variables.
 dd_c = $(srcdir)/src/dd.c
 sc_dd_max_sym_length:
+ifneq ($(wildcard $(dd_c)),)
        @len=$$( (sed -n '/conversions\[\] =$$/,/^};/p' $(dd_c);\
                 sed -n '/flags\[\] =$$/,/^};/p' $(dd_c) )      \
                |sed -n '/"/s/^[^"]*"\([^"]*\)".*/\1/p'         \
-              | wc --max-line-length);                         \
+             | wc --max-line-length);                          \
        max=$$(sed -n '/^#define LONGEST_SYMBOL /s///p' $(dd_c) \
              |tr -d '"' | wc --max-line-length);               \
        if test "$$len" = "$$max"; then :; else                 \
          echo 'dd.c: LONGEST_SYMBOL is not longest' 1>&2;      \
          exit 1;                                               \
        fi
+endif
 
 # Many m4 macros names once began with `jm_'.
 # On 2004-04-13, they were all changed to start with gl_ instead.
 # Make sure that none are inadvertently reintroduced.
 sc_prohibit_jm_in_m4:
-       @( $(CVS_LIST) ) > /dev/null 2>&1 || : &&                       \
-         grep -E 'jm_[A-Z]'                                            \
+       @grep -nE 'jm_[A-Z]'                                            \
                $$($(CVS_LIST) $(srcdir)/m4 |grep '\.m4$$') &&          \
            { echo '$(ME): do not use jm_ in m4 macro names'            \
              1>&2; exit 1; } || :
 
 sc_root_tests:
        @t1=sc-root.expected; t2=sc-root.actual;                        \
-       grep -l '^PRIV_CHECK_ARG=require-root'                          \
+       grep -nl '^PRIV_CHECK_ARG=require-root'                         \
          $$($(CVS_LIST) tests) |sed s,tests,., |sort > $$t1;           \
        sed -n 's,      cd \([^ ]*\) .*MAKE..check TESTS=\(.*\),./\1/\2,p' \
          $(srcdir)/tests/Makefile.am |sort > $$t2;                     \
@@ -205,19 +239,18 @@ sc_root_tests:
 # the headers already included via system.h.
 sc_system_h_headers: .re-list
        @if test -f $(srcdir)/src/system.h; then                        \
-         ( $(CVS_LIST) ) > /dev/null 2>&1 || exit 0;                   \
          trap 'rc=$$?; rm -f .re-list; exit $$rc' 0 1 2 3 15;          \
-         grep -E -f .re-list                                           \
-             $$($(CVS_LIST) src | grep -Ev '(copy|system)\.h$$')       \
+         grep -nE -f .re-list                                          \
+             $$($(CVS_LIST) src |                                      \
+                grep -Ev '((copy|system)\.h|parse-gram\.c)$$')         \
            && { echo '$(ME): the above are already included via system.h'\
                  1>&2;  exit 1; } || :;                                \
        fi
 
 sc_sun_os_names:
-       @( $(CVS_LIST) ) > /dev/null 2>&1 || : && \
-       grep -Ei \
+       @grep -nEi \
            'solaris[^[:alnum:]]*2\.(7|8|9|[1-9][0-9])|sunos[^[:alnum:]][6-9]' \
-         $$($(CVS_LIST) | grep -vEf .x-$@ ) &&                         \
+           $$($(CVS_LIST_EXCEPT)) &&                                   \
          { echo '$(ME): found misuse of Sun OS version numbers' 1>&2;  \
            exit 1; } || :
 
@@ -225,21 +258,48 @@ sc_tight_scope:
        $(MAKE) -C src $@
 
 sc_trailing_blank:
-       @( $(CVS_LIST) ) > /dev/null 2>&1 || : &&                       \
-         grep '[        ]$$'                                           \
-            $$($(CVS_LIST) | grep -vEf .x-$@ ) &&                      \
+       @grep -n '[      ]$$' $$($(CVS_LIST_EXCEPT)) &&                 \
          { echo '$(ME): found trailing blank(s)'                       \
                1>&2; exit 1; } || :
 
+# Match lines like the following, but where there is only one space
+# between the options and the description:
+#   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
+longopt_re = --[a-z][0-9A-Za-z-]*(\[=[0-9A-Za-z-]*\])?
+sc_two_space_separator_in_usage:
+       @grep -nE '^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
+           $$($(CVS_LIST_EXCEPT)) &&                                   \
+         { echo "$(ME): help2man requires at least two spaces between"; \
+           echo "$(ME): an option and its description"; \
+               1>&2; exit 1; } || :
+
 # Look for diagnostics that aren't marked for translation.
 # This won't find any for which error's format string is on a separate line.
 sc_unmarked_diagnostics:
-       @grep -                                                       \
-           '\<error \([^"]*"[^"]*[a-z]{3}' $(srcdir)/{lib,src}/*.c     \
-         | grep -v '_(' &&                                             \
+       @grep -nE                                                       \
+           '\<error \([^"]*"[^"]*[a-z]{3}' $$($(CVS_LIST_EXCEPT))      \
+         | grep -v '_''(' &&                                           \
          { echo '$(ME): found unmarked diagnostic(s)' 1>&2;            \
            exit 1; } || :
 
+# Avoid useless parentheses like those in this example:
+# #if defined (SYMBOL) || defined (SYM2)
+sc_useless_cpp_parens:
+       @grep -n '^# *if .*defined *(' $$($(CVS_LIST_EXCEPT)) &&        \
+         { echo '$(ME): found useless parentheses in cpp directive'    \
+               1>&2; exit 1; } || :
+
+# Ensure that the c99-to-c89 patch applies cleanly.
+# For now, it affects only remove.c.  Eventually, we'll probably
+# have to copy all of src/ before running patch.
+patch-check:
+       cp src/remove.c tmp-remove.c
+       patch -V never --fuzz=0 tmp-remove.c src/c99-to-c89.diff \
+         > $@.1 2>&1
+       sed -n '2p' $@.1 > $@.2
+       test -s $@.2 && exit 1 || :
+       rm -f tmp-remove.c $@.1 $@.2
+
 # Ensure that date's --help output stays in sync with the info
 # documentation for GNU strftime.  The only exception is %N,
 # which date accepts but GNU strftime does not.
@@ -259,20 +319,22 @@ strftime-check:
 # not @...@ in Makefile.am, now that we can rely on automake
 # to emit a definition for each substituted variable.
 makefile-check:
-       grep -E '@[A-Z_0-9]+@' `find . -name Makefile.am` \
-         && { echo 'Makefile.maint: use $(...), not @...@' 1>&2; exit 1; } || :
+       grep -nE '@[A-Z_0-9]+@' `find . -name Makefile.am` \
+         && { echo 'Makefile.maint: use $$(...), not @...@' 1>&2; exit 1; } || :
 
 news-date-check: NEWS
        today=`date +%Y-%m-%d`; \
-       if head NEWS | grep '^\*.*'$$today >/dev/null; then \
+       if head NEWS | grep '^\*.* $(VERSION_REGEXP) ('$$today')' \
+           >/dev/null; then \
          :; \
        else \
-         echo "today's date is not in NEWS" 1>&2; \
+         echo "version or today's date is not in NEWS" 1>&2; \
          exit 1; \
        fi
 
 changelog-check:
-       if head ChangeLog | grep 'Version $(VERSION)' >/dev/null; then \
+       if head ChangeLog | grep 'Version $(VERSION_REGEXP)\.$$' \
+           >/dev/null; then \
          :; \
        else \
          echo "$(VERSION) not in ChangeLog" 1>&2; \
@@ -280,19 +342,21 @@ changelog-check:
        fi
 
 m4-check:
-       @grep 'AC_DEFUN([^[]' m4/*.m4 \
+       @grep -n 'AC_DEFUN([^[]' m4/*.m4 \
          && { echo 'Makefile.maint: quote the first arg to AC_DEFUN' 1>&2; \
               exit 1; } || :
 
 # Verify that all source files using _() are listed in po/POTFILES.in.
-# FIXME: don't hard-code src/false.c below; use a more general mechanism.
+# FIXME: don't hard-code file names below; use a more general mechanism.
 po-check:
-       ( $(CVS_LIST) ) > /dev/null 2>&1 || : &&                        \
        if test -f po/POTFILES.in; then                                 \
          grep -E -v '^(#|$$)' po/POTFILES.in                           \
            | grep -v '^src/false\.c$$' | sort > $@-1;                  \
          files=;                                                       \
-         for file in $$($(CVS_LIST) lib src | grep '\.[chly]$$'); do   \
+         for file in $$($(CVS_LIST_EXCEPT)) lib/*.[ch]; do             \
+           case $$file in                                              \
+           djgpp/* | man/*) continue;;                                 \
+           esac;                                                       \
            case $$file in                                              \
            *.[ch])                                                     \
              base=`expr " $$file" : ' \(.*\)\..'`;                     \
@@ -300,7 +364,7 @@ po-check:
            esac;                                                       \
            files="$$files $$file";                                     \
          done;                                                         \
-         grep -E -l '\bN?_\([^)"]*("|$$)' $$files | sort > $@-2;       \
+         grep -E -l '\bN?_\([^)"]*("|$$)' $$files | sort -u > $@-2;    \
          diff -u $@-1 $@-2 || exit 1;                                  \
          rm -f $@-1 $@-2;                                              \
        fi
@@ -309,7 +373,7 @@ po-check:
 # the English word `and', the string must be marked with `N_ (...)' so that
 # gettext recognizes it as a string requiring translation.
 author_mark_check:
-       @grep '^# *define AUTHORS "[^"]* and ' src/*.c |grep -v ' N_ (' && \
+       @grep -n '^# *define AUTHORS "[^"]* and ' src/*.c |grep -v ' N_ (' && \
          { echo 'Makefile.maint: enclose the above strings in N_ (...)' 1>&2; \
            exit 1; } || :
 
@@ -321,7 +385,7 @@ author_mark_check:
 # that we'd have to worry about limits on command line length.
 msg = 'Makefile.maint: Do not use `:'\'' above; use @PATH_SEPARATOR@ instead'
 makefile_path_separator_check:
-       @grep 'PATH=.*:' `find $(srcdir) -name Makefile.am` \
+       @grep -n 'PATH=.*:' `find $(srcdir) -name Makefile.am` \
          && { echo $(msg) 1>&2; exit 1; } || :
 
 # Check that `make alpha' will not fail at the end of the process.
@@ -338,11 +402,11 @@ writable-files:
        done;                                                           \
        test "$$fail" && exit 1 || :
 
-v_etc_file = lib/version-etc-fsf.c
+v_etc_file = lib/version-etc.c
 # Make sure that the copyright date in $(v_etc_file) is up to date.
 copyright-check:
        @if test -f $(v_etc_file); then \
-         grep '"Copyright (C) $(shell date +%Y) Free' $(v_etc_file) \
+         grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
            >/dev/null \
          || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
               exit 1; }; \
@@ -368,7 +432,7 @@ cvs-diff-check:
 
 cvs-check: cvs-diff-check cvs-tag-check
 
-maintainer-distcheck: changelog-check
+maintainer-distcheck:
        $(MAKE) distcheck
        $(MAKE) my-distcheck
 
@@ -394,15 +458,17 @@ null_AM_MAKEFLAGS = \
 # by the use of _().  The --disable-nls effectively defines away that macro,
 # and building with CFLAGS='-Wformat -Werror' causes any format warning to be
 # treated as a failure.  Also, check for shadowing problems with -Wshadow.
+# These CFLAGS are pretty strict.  If you build this target, you probably
+# have to have a recent version of gcc and glibc headers.
 TMPDIR ?= /tmp
 t=$(TMPDIR)/$(PACKAGE)/test
-my-distcheck: $(local-check)
+my-distcheck: $(local-check) $(release_archive_dir)/$(prev-tgz)
        -rm -rf $(t)
        mkdir -p $(t)
        GZIP=$(GZIP_ENV) $(AMTAR) -C $(t) -zxf $(distdir).tar.gz
        cd $(t)/$(distdir)                              \
          && ./configure --disable-nls                  \
-         && $(MAKE) CFLAGS='-Wformat -Werror -Wshadow' \
+         && $(MAKE) CFLAGS='-Werror -Wall -Wformat -Wshadow' \
              AM_MAKEFLAGS='$(null_AM_MAKEFLAGS)'       \
          && $(MAKE) dvi                                \
          && $(MAKE) check                              \
@@ -418,16 +484,6 @@ my-distcheck: $(local-check)
 WGET = wget
 WGETFLAGS = -C off
 
-tgz-md5 = $(shell md5sum < $(my_distdir).tar.gz|sed 's/  -//')
-tgz-sha1 = $(shell sha1sum < $(my_distdir).tar.gz|sed 's/  -//')
-bz2-md5 = $(shell md5sum < $(my_distdir).tar.bz2|sed 's/  -//')
-bz2-sha1 = $(shell sha1sum < $(my_distdir).tar.bz2|sed 's/  -//')
-xdelta-md5 = $(shell md5sum < $(xd-delta)|sed 's/  -//')
-xdelta-sha1 = $(shell sha1sum < $(xd-delta)|sed 's/  -//')
-tgz-size = $(shell du --human $(my_distdir).tar.gz|sed 's/\([MkK]\).*/ \1B/')
-bz2-size = $(shell du --human $(my_distdir).tar.bz2|sed 's/\([MkK]\).*/ \1B/')
-xd-size = $(shell du --human $(xd-delta)|sed 's/\([MkK]\).*/ \1B/')
-
 rel-check:
        tarz=/tmp/rel-check-tarz-$$$$; \
        md5_tmp=/tmp/rel-check-md5-$$$$; \
@@ -448,6 +504,7 @@ announcement: NEWS ChangeLog $(rel-files)
            --prev=$(PREV_VERSION)                                      \
            --curr=$(VERSION)                                           \
            --release-archive-directory=$(release_archive_dir)          \
+           --gpg-key-id=$(gpg_key_ID)                                  \
            --news=NEWS                                                 \
            $(addprefix --url-dir=, $(url_dir_list))                    \
 
@@ -555,7 +612,6 @@ emit_upload_commands:
        @echo =====================================
        @echo =====================================
        @echo "$(srcdir)/gnupload $(GNUPLOADFLAGS) \\"
-       @echo "    --to fetish.sf.net:fetish-ftp \\"
        @echo "    --to $(gnu_rel_host):coreutils \\"
        @echo "  $(rel-files)"
        @echo '# send the /tmp/announcement e-mail'
@@ -566,7 +622,11 @@ $(xd-delta): $(release_archive_dir)/$(prev-tgz) $(distdir).tar.gz
        xdelta delta -9 $^ $@ || :
 
 .PHONY: alpha beta major
-alpha beta major: news-date-check $(local-check)
+alpha beta major: news-date-check changelog-check $(local-check)
+       test $@ = major                                         \
+         && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
+              || { echo "invalid version string: $(VERSION)" 1>&2; exit 1; }}\
+         || :
        $(MAKE) cvs-dist
        $(MAKE) $(xd-delta)
        $(MAKE) -s announcement RELEASE_TYPE=$@ > /tmp/announce-$(my_distdir)